Bug 804259

Summary: Slow 802.11n performance with Intel Centrino Ultimate-N 6300 (iwlwifi) coupled with dd-wrt router
Product: [Fedora] Fedora Reporter: Chris Hudson <chhudson>
Component: kernelAssignee: John W. Linville <linville>
Status: CLOSED INSUFFICIENT_DATA QA Contact: Fedora Extras Quality Assurance <extras-qa>
Severity: high Docs Contact:
Priority: unspecified    
Version: 16CC: accounts+redhat, adlorenz, alexl, artur.cuvasov, daryll, gansalmon, havardw, ilw, itamar, jforbes, jonathan, jvpgomes, kernel-maint, lecotegougdelaforce, madhu.chinakonda, mads, nikodll, pauljohn, s2jawalt, sdake, sgruszka, sune, vbatts, ventero, wey-yi.w.guy, ykaul
Target Milestone: ---Keywords: CommonBugs
Target Release: ---   
Hardware: x86_64   
OS: Linux   
Whiteboard: https://fedoraproject.org/wiki/Common_F16_bugs#iwl-router-kill
Fixed In Version: Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: 708747 Environment:
Last Closed: 2012-11-13 10:07:34 EST Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Bug Depends On: 708747    
Bug Blocks: 735721    
Attachments:
Description Flags
DVM fix none

Description Chris Hudson 2012-03-16 23:17:34 EDT
+++ This bug was initially created as a clone of Bug #708747 +++

Description of problem:
Bit rate drops to an unusable rate when connected when connected via 802.11n to a Linksys e3000 router running dd-wrt.

Version-Release number of selected component (if applicable):
kernel-3.2.9-2.fc16.x86_64

How reproducible: 
Always

Steps to Reproduce:
1. Connect to wireless network (Linksys e3000 with dd-wrt firmware in this case)
2. Notice a relatively quick slowdown in bit rate
  
Actual results:
Extremely low bit rate

Expected results:
A higher bit rate

Additional info:

Seems to work fine if router is set to provide B/G only.

[37870.955151] iwlwifi 0000:03:00.0: Detected Intel(R) Centrino(R) Ultimate-N 6300 AGN, REV=0x74
[37870.955229] iwlwifi 0000:03:00.0: L1 Enabled; Disabling L0S
[37870.964299] iwlwifi 0000:03:00.0: device EEPROM VER=0x436, CALIB=0x6
[37870.964301] iwlwifi 0000:03:00.0: Device SKU: 0x1F0
[37870.964303] iwlwifi 0000:03:00.0: Valid Tx ant: 0x7, Valid Rx ant: 0x7
[37870.964331] iwlwifi 0000:03:00.0: Tunable channels: 13 802.11bg, 24 802.11a channels
[37870.969867] iwlwifi 0000:03:00.0: loaded firmware version 9.221.4.1 build 25532
[37870.981620] iwlwifi 0000:03:00.0: L1 Enabled; Disabling L0S
[37870.981814] iwlwifi 0000:03:00.0: Radio type=0x0-0x3-0x1
[37871.217203] iwlwifi 0000:03:00.0: L1 Enabled; Disabling L0S
[37871.217397] iwlwifi 0000:03:00.0: Radio type=0x0-0x3-0x1
[37995.029776] iwlwifi 0000:03:00.0: L1 Enabled; Disabling L0S
[37995.029974] iwlwifi 0000:03:00.0: Radio type=0x0-0x3-0x1
Comment 1 Stanislaw Gruszka 2012-03-19 04:02:09 EDT
Yet another 11n problem. You can disable that on iwlwifi driver using 11n_disable module parameter.
Comment 2 Yaniv Kaul 2012-03-19 04:15:03 EDT
(In reply to comment #1)
> Yet another 11n problem. You can disable that on iwlwifi driver using
> 11n_disable module parameter.

Disabling 802.11n doesn't sound like a great solution to me.
Comment 3 Dave Jones 2012-03-22 12:37:56 EDT
[mass update]
kernel-3.3.0-4.fc16 has been pushed to the Fedora 16 stable repository.
Please retest with this update.
Comment 4 Dave Jones 2012-03-22 12:43:19 EDT
[mass update]
kernel-3.3.0-4.fc16 has been pushed to the Fedora 16 stable repository.
Please retest with this update.
Comment 5 Dave Jones 2012-03-22 12:51:17 EDT
[mass update]
kernel-3.3.0-4.fc16 has been pushed to the Fedora 16 stable repository.
Please retest with this update.
Comment 6 Chris Hudson 2012-03-23 13:29:39 EDT
Will test with new kernel shortly, thanks
Comment 7 Chris Hudson 2012-03-23 23:03:05 EDT
Same results with new kernel:

---
$ uname -r
3.3.0-4.fc16.x86_64
---

---
$ iwconfig wlan0
wlan0     IEEE 802.11abgn  ESSID:"w00t"  
          Mode:Managed  Frequency:2.412 GHz  Access Point: C0:C1:C0:56:87:82   
          Bit Rate=1 Mb/s   Tx-Power=15 dBm   
          Retry  long limit:7   RTS thr:off   Fragment thr:off
          Power Management:off
          Link Quality=62/70  Signal level=-48 dBm  
          Rx invalid nwid:0  Rx invalid crypt:0  Rx invalid frag:0
          Tx excessive retries:98  Invalid misc:17   Missed beacon:0
---

---
$ dmesg | grep iwlwifi
[   17.182610] iwlwifi 0000:03:00.0: pci_resource_len = 0x00002000
[   17.182612] iwlwifi 0000:03:00.0: pci_resource_base = ffffc90005890000
[   17.182614] iwlwifi 0000:03:00.0: HW Revision ID = 0x35
[   17.182771] iwlwifi 0000:03:00.0: irq 50 for MSI/MSI-X
[   17.182834] iwlwifi 0000:03:00.0: CONFIG_IWLWIFI_DEBUG enabled
[   17.182836] iwlwifi 0000:03:00.0: CONFIG_IWLWIFI_DEBUGFS enabled
[   17.182838] iwlwifi 0000:03:00.0: CONFIG_IWLWIFI_DEVICE_TRACING disabled
[   17.182840] iwlwifi 0000:03:00.0: CONFIG_IWLWIFI_DEVICE_TESTMODE disabled
[   17.182842] iwlwifi 0000:03:00.0: CONFIG_IWLWIFI_P2P disabled
[   17.182872] iwlwifi 0000:03:00.0: Detected Intel(R) Centrino(R) Ultimate-N 6300 AGN, REV=0x74
[   17.182943] iwlwifi 0000:03:00.0: L1 Enabled; Disabling L0S
[   17.192322] iwlwifi 0000:03:00.0: device EEPROM VER=0x436, CALIB=0x6
[   17.192324] iwlwifi 0000:03:00.0: Device SKU: 0x1F0
[   17.192326] iwlwifi 0000:03:00.0: Valid Tx ant: 0x7, Valid Rx ant: 0x7
[   17.192360] iwlwifi 0000:03:00.0: Tunable channels: 13 802.11bg, 24 802.11a channels
[   17.196651] iwlwifi 0000:03:00.0: loaded firmware version 9.221.4.1 build 25532
[   22.810061] iwlwifi 0000:03:00.0: L1 Enabled; Disabling L0S
[   22.810253] iwlwifi 0000:03:00.0: Radio type=0x0-0x3-0x1
[   23.046246] iwlwifi 0000:03:00.0: L1 Enabled; Disabling L0S
[   23.046436] iwlwifi 0000:03:00.0: Radio type=0x0-0x3-0x1
[18525.158178] iwlwifi 0000:03:00.0: L1 Enabled; Disabling L0S
[18525.158374] iwlwifi 0000:03:00.0: Radio type=0x0-0x3-0x1
[19043.744780] iwlwifi 0000:03:00.0: Queue 2 stuck for 2000 ms.
[19043.744785] iwlwifi 0000:03:00.0: Current SW read_ptr 201 write_ptr 202
[19043.744838] iwlwifi 0000:03:00.0: Current HW read_ptr 202 write_ptr 202
[19043.744841] iwlwifi 0000:03:00.0: On demand firmware reload
[19043.745318] iwlwifi 0000:03:00.0: L1 Enabled; Disabling L0S
[19043.745495] iwlwifi 0000:03:00.0: Radio type=0x0-0x3-0x1
---
Comment 8 Michael Zabriskie 2012-04-02 12:03:30 EDT
I am having the same problem as well. FC16, Intel Centrino Ultimate-N 6300, HP MSM422 wireless AP. 11N connections will work for a short period of time at a good speed and then completely drop off and will pass no traffic. Pinging the wifi AP isn't even possible.
Comment 9 Paul Johnson 2012-04-18 23:34:49 EDT
Dear Michael and Chris:

I may have good news. At least something worth testing. 

I have RedHat and Debian systems, lately I've been wrestling with Debian. With kernel 3.2, I've had success this week with iwlwifi on Dell Precision M4600 systems.  I have Intel Centrino Ultimate N-6300. 

I see the same problems described in this thread, and i've found about 50 different websites where people claim the problem is solved if we install a "new" firmware (that is not yet released by Intel) or if we fiddle the module settings somehow. I've tried all of these, and I'm having some success for the past 2 days with this particular combination:

$ cat /etc/modprobe.d/iwlwifi.conf
options iwlwifi power_save=0 swcrypto=1 bt_coex_active=0


The system does not always associate right away, but if I remove the iwlwifi module and reinstall it, then it generally does. Know what I mean?

$ sudo /sbin/modprobe -r iwlwifi
$ sudo /sbin/modprobe iwlwifi

I have NO SUCCESS with kernels in the 3.1.x series, but with releases of 3.2, I have pretty good results. I have no idea if the following is informative to you, it does reveal the firmware edition.  This is for a session when the device failed to join the wireless router, and then it did join after modprobe re-loaded the module.

Here's the end of dmesg output:

[   13.664978] EXT4-fs (sda7): mounted filesystem with ordered data mode. Opts: (null)
[   13.751829] kjournald starting.  Commit interval 5 seconds
[   13.752067] EXT3-fs (sda6): using internal journal
[   13.752185] EXT3-fs (sda6): mounted filesystem with ordered data mode
[   17.366034] iwlwifi 0000:03:00.0: L1 Enabled; Disabling L0S
[   17.366341] iwlwifi 0000:03:00.0: Radio type=0x0-0x3-0x1
[   17.609951] iwlwifi 0000:03:00.0: L1 Enabled; Disabling L0S
[   17.610256] iwlwifi 0000:03:00.0: Radio type=0x0-0x3-0x1
[   17.738909] ADDRCONF(NETDEV_UP): wlan0: link is not ready
[   18.354564] fuse init (API version 7.17)
[   22.744658] e1000e 0000:00:19.0: irq 41 for MSI/MSI-X
[   22.800472] e1000e 0000:00:19.0: irq 41 for MSI/MSI-X
[   22.800784] ADDRCONF(NETDEV_UP): eth0: link is not ready
[   24.949017] input: ACPI Virtual Keyboard Device as /devices/virtual/input/input18
[   26.116754] lp: driver loaded but no devices found
[   26.202770] ppdev: user-space parallel port driver
[   27.147616] spurious 8259A interrupt: IRQ7.
[   33.252954] tun: Universal TUN/TAP device driver, 1.6
[   33.252959] tun: (C) 1999-2004 Max Krasnyansky <maxk@qualcomm.com>
[   36.527329] ip_tables: (C) 2000-2006 Netfilter Core Team
[   36.585376] ip6_tables: (C) 2000-2006 Netfilter Core Team
[   77.771251] device-mapper: uevent: version 1.0.3
[   77.771456] device-mapper: ioctl: 4.22.0-ioctl (2011-10-19) initialised: dm-devel@redhat.com
[   77.980687] alg: No test for __gcm-aes-aesni (__driver-gcm-aes-aesni)
[   78.145097] EXT4-fs (dm-0): warning: maximal mount count reached, running e2fsck is recommended
[   78.157690] EXT4-fs (dm-0): mounted filesystem with ordered data mode. Opts: (null)
[  391.543157] wlan0: authenticate with 5c:d9:98:65:64:b0 (try 1)
[  391.549548] wlan0: authenticated
[  391.647107] wlan0: associate with 5c:d9:98:65:64:b0 (try 1)
[  391.649600] wlan0: deauthenticated from 5c:d9:98:65:64:b0 (Reason: 9)
[  426.428085] wlan0: authenticate with 5c:d9:98:65:64:b0 (try 1)
[  426.429964] wlan0: authenticated
[  426.430375] wlan0: failed to insert Dummy STA entry for the AP (error -17)
[  454.356190] wlan0: deauthenticating from 5c:d9:98:65:64:b0 by local choice (reason=2)
[  454.406017] wlan0: authenticate with 5c:d9:98:65:64:b0 (try 1)
[  454.407829] wlan0: authenticated
[  454.408193] wlan0: failed to insert Dummy STA entry for the AP (error -17)
[  494.145827] wlan0: deauthenticating from 5c:d9:98:65:64:b0 by local choice (reason=2)
[  494.195100] wlan0: authenticate with 5c:d9:98:65:64:b0 (try 1)
[  494.197360] wlan0: authenticated
[  494.197767] wlan0: failed to insert Dummy STA entry for the AP (error -17)
[  520.244751] wlan0: deauthenticating from 5c:d9:98:65:64:b0 by local choice (reason=2)
[  520.293357] wlan0: authenticate with 5c:d9:98:65:64:b0 (try 1)
[  520.295218] wlan0: authenticated
[  520.295598] wlan0: failed to insert Dummy STA entry for the AP (error -17)
[  522.069724] wlan0: deauthenticating from 5c:d9:98:65:64:b0 by local choice (reason=3)
[  522.253824] iwlwifi 0000:03:00.0: PCI INT A disabled
[  530.851085] cfg80211: Calling CRDA to update world regulatory domain
[  530.854627] Intel(R) Wireless WiFi Link AGN driver for Linux, in-tree:
[  530.854630] Copyright(c) 2003-2011 Intel Corporation
[  530.854724] iwlwifi 0000:03:00.0: PCI INT A -> Link[LNKB] -> GSI 11 (level, low) -> IRQ 11
[  530.854789] iwlwifi 0000:03:00.0: setting latency timer to 64
[  530.854834] iwlwifi 0000:03:00.0: pci_resource_len = 0x00002000
[  530.854837] iwlwifi 0000:03:00.0: pci_resource_base = ffffc90000660000
[  530.854839] iwlwifi 0000:03:00.0: HW Revision ID = 0x35
[  530.855166] iwlwifi 0000:03:00.0: irq 48 for MSI/MSI-X
[  530.855279] iwlwifi 0000:03:00.0: Detected Intel(R) Centrino(R) Ultimate-N 6300 AGN, REV=0x74
[  530.855441] iwlwifi 0000:03:00.0: L1 Enabled; Disabling L0S
[  530.857669] cfg80211: World regulatory domain updated:
[  530.857676] cfg80211:     (start_freq - end_freq @ bandwidth), (max_antenna_gain, max_eirp)
[  530.857682] cfg80211:     (2402000 KHz - 2472000 KHz @ 40000 KHz), (300 mBi, 2000 mBm)
[  530.857686] cfg80211:     (2457000 KHz - 2482000 KHz @ 20000 KHz), (300 mBi, 2000 mBm)
[  530.857689] cfg80211:     (2474000 KHz - 2494000 KHz @ 20000 KHz), (300 mBi, 2000 mBm)
[  530.857696] cfg80211:     (5170000 KHz - 5250000 KHz @ 40000 KHz), (300 mBi, 2000 mBm)
[  530.857699] cfg80211:     (5735000 KHz - 5835000 KHz @ 40000 KHz), (300 mBi, 2000 mBm)
[  530.866056] iwlwifi 0000:03:00.0: device EEPROM VER=0x43a, CALIB=0x6
[  530.866058] iwlwifi 0000:03:00.0: Device SKU: 0X1f0
[  530.866060] iwlwifi 0000:03:00.0: Valid Tx ant: 0X7, Valid Rx ant: 0X7
[  530.866079] iwlwifi 0000:03:00.0: Tunable channels: 13 802.11bg, 24 802.11a channels
[  530.868260] iwlwifi 0000:03:00.0: loaded firmware version 9.221.4.1 build 25532
[  530.868474] Registered led device: phy0-led
[  530.868537] ieee80211 phy0: Selected rate control algorithm 'iwl-agn-rs'
[  530.874756] iwlwifi 0000:03:00.0: L1 Enabled; Disabling L0S
[  530.874956] iwlwifi 0000:03:00.0: Radio type=0x0-0x3-0x1
[  531.118811] iwlwifi 0000:03:00.0: L1 Enabled; Disabling L0S
[  531.119038] iwlwifi 0000:03:00.0: Radio type=0x0-0x3-0x1
[  531.252878] ADDRCONF(NETDEV_UP): wlan0: link is not ready
[  539.012262] wlan0: authenticate with 5c:d9:98:65:64:b0 (try 1)
[  539.014140] wlan0: authenticated
[  539.111838] wlan0: associate with 5c:d9:98:65:64:b0 (try 1)
[  539.117851] wlan0: RX AssocResp from 5c:d9:98:65:64:b0 (capab=0x431 status=0 aid=1)
[  539.117864] wlan0: associated
[  539.124622] ADDRCONF(NETDEV_CHANGE): wlan0: link becomes ready
[  549.228058] wlan0: no IPv6 routers present
Comment 10 Adam Williamson 2012-05-04 09:03:10 EDT

-- 
Fedora Bugzappers volunteer triage team
https://fedoraproject.org/wiki/BugZappers
Comment 11 Steven Dake 2012-06-24 11:47:41 EDT
I was having problems shown in this thread with F17 3.4.3 kernel.  I tried kernel 3.4.4-1 from koji, and it seems to repair the wireless problems in 3.4.3-1 shipped with F17.
Comment 12 Skippy 2012-08-04 11:22:17 EDT
Experiencing the same very slow wifi issue with kernel 3.4.6-1.fc16.i686 on a 802.11g (French Freebox 5C) with the same wireless card (from a Dell Latitude E6410).  For one or two seconds the connection seems fine, then the download rate goes from ~1 MB/s down to a few B/s (no, I didn't forget a K…), then sometimes even below 1 B/s.  Really a pain as you can imagine…

Paul's suggestion of disabling options did the trick.
Comment 13 Dave Jones 2012-10-23 11:26:13 EDT
# Mass update to all open bugs.

Kernel 3.6.2-1.fc16 has just been pushed to updates.
This update is a significant rebase from the previous version.

Please retest with this kernel, and let us know if your problem has been fixed.

In the event that you have upgraded to a newer release and the bug you reported
is still present, please change the version field to the newest release you have
encountered the issue with.  Before doing so, please ensure you are testing the
latest kernel update in that release and attach any new and relevant information
you may have gathered.

If you are not the original bug reporter and you still experience this bug,
please file a new report, as it is possible that you may be seeing a
different problem. 
(Please don't clone this bug, a fresh bug referencing this bug in the comment is sufficient).
Comment 14 Justin M. Forbes 2012-11-13 10:07:34 EST
With no response, we are closing this bug under the assumption that it is no longer an issue. If you still experience this bug, please feel free to reopen the bug report.
Comment 15 Artur Cuvasov 2013-04-07 14:46:16 EDT
I am experiencing this issue after a recent package update on FC18. The speedtest is "ragged" and does not go faster than 12Mbps. It used to work fine just a week ago. It does not seem to be a kernel issue as I tried to load 3.8.3 (3.8.5 is current). b/g is working fine.
Comment 16 Artur Cuvasov 2013-04-07 17:06:11 EDT
After several tests I came up to the following conclusion:

Kernel 3.8.5-201:
Works fine right a reboot, shows up to 100Mbps (broadband limit is 140Mbps). After approx. 10 minutes the maximum I could get varies from 1 to 8Mbps.

Kernel 3.6.11-7
No problems with N noticed.

Ultimate-N 6300 AGN, REV=0x74
ASUS RT-N66U
Comment 17 Artur Cuvasov 2013-04-11 13:14:10 EDT
Please reopen the bug.
Comment 18 Emmanuel Grumbach 2013-04-14 02:26:30 EDT
Created attachment 735527 [details]
DVM fix

can you please test the patch attached?